﻿' This script uses WhatIsMyIP.com's automation page
' http://www.whatismyip.com/automation/n09230945.asp
Function WMIDate(wDate)
 On Error Resume Next
 Dim gMin
 WMIDate = ""
 gMin = Mid(wDate,23,3) Mod 60
 If gMin < 10 Then
  gMin = "0" & gMin
 End If
 WMIDate = Mid(wDate, 7, 2) & " " & MonthName(Mid(wDate, 5, 2), True) & " " &  Left(wDate, 4)  & " " & TimeSerial( Mid(wDate, 9, 2),  Mid(wDate, 11, 2),  Mid(wDate, 13, 2)) & " GMT" & Mid(wDate,22,1) & Mid(wDate,23,3)\60 & ":" & gMin
End Function

Function GetLanIp(A)
 On Error Resume Next
 Dim objWMI, objLocator, colItems, strQuery, objItem, strDesc
 strQuery = "SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = True"
 Set objLocator = CreateObject( "WbemScripting.SWbemLocator" )
 Set objWMI = objLocator.ConnectServer( ".", "root\CIMV2" )
 objWMI.Security_.ImpersonationLevel = 3
 Set colItems = objWMI.ExecQuery( strQuery, "WQL", 0 )
 strDesc = "Network"
 If A = "list" Then
  For Each objItem In colItems
   If isNull( objItem.IPAddress ) = false Then
    If strDesc = "Network" Then
     strDesc = objItem.Description
    Else
     strDesc = strDesc & ";" & objItem.Description
    End If
   End If
  Next
  GetLanIp = strDesc
 Else
 Dim strIP, strMAC, strName, strIPsix, strSubNet, strGate, bDHCP, strDHCPserver, strDNSa, strDNSb, strNB, strLO, strLE
 strIP = "0.0.0.0"
 strIPSix = "Not Enabled"
 strMAC = "MAC Unknown"
 strName = "Adapter"
 strSubNet = "Unknown"
 strGate = "Unknown"
 bDHCP = "false"
 strDHCPserver = ""
 strDNSa = "Unknown"
 strDNSb = ""
 strNB = "Unknown"
' If an info adapter is not set (like on install)
' make the info adapter the FIRST adapter with an ip that is also either:
' - DHCP enabled and connected (for dynamic ip) - adds to startup overhead - uncomment block below to use
' - if no dhcp then just connected {for static ip}

'  If A = false Then
'   For Each objItem In colItems
'    If objItem.DHCPEnabled = true Then
'     A = objItem.Description
'     Exit For
'    End If
'   Next
'  End If

 For Each objItem In colItems
  If isNull( objItem.IPAddress ) = false Then
   If A = false Then
    A = objItem.Description
   End If
   If objItem.Description = A Then
    strIP = objItem.IPAddress(0)
    strMAC = objItem.MACAddress(0)
    strDesc = A
    If isNull(objItem.ServiceName) = false Then
     strName = objItem.ServiceName(0)
    End If
    strIPSix = objItem.IPAddress(1)
    strSubNet = objItem.IPSubnet(0)
    If isNull( objItem.DefaultIPGateway ) = false Then
     strGate = objItem.DefaultIPGateway(0)
    End If
    bDHCP = objItem.DHCPEnabled(0)
    If isNull( objItem.DHCPServer ) = false Then
     strDHCPserver = objItem.DHCPServer(0)
    End If
    If isNull( objItem.DNSServerSearchOrder )= false Then
     strDNSa = objItem.DNSServerSearchOrder(0) 
     strDNSb = objItem.DNSServerSearchOrder(1) 
    End If
    If isNull( objItem.TcpipNetbiosOptions ) = false Then
     Select Case objItem.TcpipNetbiosOptions
      Case 0 strNB = "Enabled via DHCP"
      Case 1 strNB = "Enabled"
      Case 2 strNB = "Disabled"
     End Select
    End If
    If isNull( objItem.DHCPLeaseObtained ) = false Then
     strLO =  WMIDate(objItem.DHCPLeaseObtained)
    End If
    If isNull( objItem.DHCPLeaseExpires ) = false Then
     strLE = WMIDate(objItem.DHCPLeaseExpires)
    End If
    Exit For
   End If
  End If
 Next
 GetLanIP = strIP & ";" & strMAC & ";" & strDesc & ";" & strName & ";" & "Acquiring;" & strIPSix & ";" & strSubNet & ";" & strGate & ";" & bDHCP & ";" & strDHCPserver & ";" & strDNSa & ";" & strDNSb & ";" & strNB & ";" & strLO & ";" & strLE
 End If
 Set colItems = Nothing
 Set objWMI = Nothing
 Set objLocator = Nothing
End Function

Function GetWanIp()
 On Error Resume Next
 Dim objHTTP, strURL, intTimer
 strURL = "http://www.whatismyip.com/automation/n09230945.asp"
 Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
 GetWanIp = "0.0.0.0"
 intTimer = 0
 objHTTP.Open "GET", strURL, True
 objHTTP.Send
 Do
  objHTTP.WaitForResponse = 1 
  intTimer = intTimer + 1
 Loop Until objHTTP.Status = 200 Or intTimer = 20
 If objHTTP.Status = 200 Then
  GetWanIp = objHTTP.ResponseText
 End If
 Set objHTTP = Nothing
End Function

Function PingHome(A,B)
 On Error Resume Next
 Dim objLocator, objWMI, colItems, strQuery, sa, sb, sc
 sa = -1
 sb = 0
 sc = "TO"
 PingHome = false
 A = CStr( A )
 strQuery = "Select * from Win32_PingStatus " & "Where Address = '" & A & "'"
 Set objLocator = CreateObject( "WbemScripting.SWbemLocator" )
 Set objWMI = objLocator.ConnectServer( ".", "root\CIMV2" )
 Set colItems = objWMI.ExecQuery( strQuery, "WQL", 32 )
 For Each objItem in colItems
  sa = objItem.StatusCode
  If sa = 0 Then
   sb = objItem.ReplySize
   sc = objItem.ResponseTime
  End If
 Next
 If B = 2 Then
  PingHome = sa & ";" & sb & ";" & sc
 End If
 If B = 1 And sa = 0 Then
  PingHome = true
 End If
 Set objLocator = Nothing
 Set objWMI = Nothing
 Set colItems = Nothing
End Function
